/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package com.liferay.portlet.documentlibrary.action;

import com.liferay.portal.util.Constants;
import com.liferay.portlet.documentlibrary.ejb.DLFileProfileManagerUtil;
import com.liferay.portlet.documentlibrary.model.DLFileProfile;
import com.liferay.util.FileUtil;
import com.liferay.util.ParamUtil;
import com.liferay.util.StringUtil;
//RMS-I
import com.liferay.util.RMSCoder;
//RMS-F
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.PageContext;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * <a href="GetFileVersionAction.java.html"><b><i>View Source</i></b></a>
 *
 * @author  Brian Wing Shun Chan
 * @version $Revision: 1.5 $
 *
 */
public class GetFileVersionAction extends Action {

	public ActionForward execute(
			ActionMapping mapping, ActionForm form, HttpServletRequest req,
			HttpServletResponse res)
		throws Exception {

		try {
			String repositoryId = ParamUtil.getString(req, "repository_id");

                        //RMS-I
                        //String path = ParamUtil.getString(req, "file_path");
                        //String name = ParamUtil.getString(req, "file_name");
                        String path = RMSCoder.RMSDecode(ParamUtil.getString(req, "file_path"));
                        String name = RMSCoder.RMSDecode(ParamUtil.getString(req, "file_name"));
                        //RMS-F
			String fileName = StringUtil.replace(path + "/" + name, "//", "/");

			double version = ParamUtil.get(
				req, "file_version", DLFileProfile.DEFAULT_VERSION);

			byte[] byteArray = DLFileProfileManagerUtil.getFile(
				repositoryId, fileName, version);

			String shortFileName = FileUtil.getShortFileName(fileName);

			res.setHeader("Cache-Control", "public");
			res.setHeader("Pragma", "public");

			res.setHeader(
				"Content-Disposition",
				"attachment; filename=\"" + shortFileName + "\"");

			res.getOutputStream().write(byteArray);
			res.getOutputStream().flush();

			return mapping.findForward(Constants.COMMON_NULL);
		}
		catch (Exception e) {
			req.setAttribute(PageContext.EXCEPTION, e);

			return mapping.findForward(Constants.COMMON_ERROR);
		}
	}

}