<%
/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/document_library/init.jsp" %>
<%@ page import="com.liferay.util.RMSCoder" %>

<%
DLRepository repository = (DLRepository)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_REPOSITORY);

String path = request.getParameter("file_path");
if ((path == null) || (path.equals("null"))) {
	path = "/";
}
//RMS-I
else{
    path = RMSCoder.RMSDecode(request.getParameter("file_path"));
}
//RMS-F

String name = request.getParameter("file_name");
if ((name == null) || (name.equals("null"))) {
	name = "";
}
//RMS-I
else{
    name = RMSCoder.RMSDecode(request.getParameter("file_name"));
}
//RMS-F

// All roles

Role[] roles = (Role[])CompanyLocalManagerUtil.getRoles(company.getCompanyId()).toArray(new Role[0]);

// Read roles

String[] readRoleNames = StringUtil.split(ParamUtil.getString(request, "file_rr"));
String readRoleNamesParam = request.getParameter("file_rr");
if (readRoleNamesParam == null) {
	readRoleNames = StringUtil.split(repository.getReadRoles());
}
List readRolesList = new ArrayList();
Set readRolesSet = new HashSet();
for (int i = 0; i < readRoleNames.length; i++) {
	try {
		Role readRole = RoleLocalManagerUtil.getRoleByName(company.getCompanyId(), readRoleNames[i]);

		readRolesList.add(readRole);
		readRolesSet.add(readRole);
	}
	catch (Exception e) {
	}
}
Role[] readRoles = (Role[])readRolesList.toArray(new Role[0]);

// Write roles

String[] writeRoleNames = StringUtil.split(ParamUtil.getString(request, "file_wr"));
String writeRoleNamesParam = request.getParameter("file_wr");
if (writeRoleNamesParam == null) {
	writeRoleNames = StringUtil.split(repository.getWriteRoles());
}
List writeRolesList = new ArrayList();
Set writeRolesSet = new HashSet();
for (int i = 0; i < writeRoleNames.length; i++) {
	try {
		Role writeRole = RoleLocalManagerUtil.getRoleByName(company.getCompanyId(), writeRoleNames[i]);

		writeRolesList.add(writeRole);
		writeRolesSet.add(writeRole);
	}
	catch (Exception e) {
	}
}
Role[] writeRoles = (Role[])writeRolesList.toArray(new Role[0]);
%>

<form action="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/add_file" /></portlet:actionURL>" enctype="multipart/form-data" method="post" name="<portlet:namespace />fm" onSubmit="<liferay:upload-progress /> document.<portlet:namespace />fm.<portlet:namespace />file_rr.value = listSelect(document.<portlet:namespace />fm.<portlet:namespace />file_sel_rr2); document.<portlet:namespace />fm.<portlet:namespace />file_wr.value = listSelect(document.<portlet:namespace />fm.<portlet:namespace />file_sel_wr2); submitForm(this); return false;">
<input name="<portlet:namespace /><%= Constants.CMD %>" type="hidden" value="<%= Constants.ADD %>">
<input name="<portlet:namespace />redirect" type="hidden" value="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/view_repository" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /></portlet:renderURL>">
<input name="<portlet:namespace />repository_id" type="hidden" value="<%= repository.getRepositoryId() %>">
<input name="<portlet:namespace />file_path" type="hidden" value="<%= path %>">
<input name="<portlet:namespace />file_rr" type="hidden" value="">
<input name="<portlet:namespace />file_wr" type="hidden" value="">

<c:if test="<%= !SessionErrors.isEmpty(renderRequest) %>">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "you-have-entered-invalid-data") %></span></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<liferay:box top="/html/common/box_top.jsp" bottom="/html/common/box_bottom.jsp">
	<liferay:param name="box_title" value="<%= LanguageUtil.get(pageContext, \"add-document\") %>" />

	<table border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "document-path") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= path %></font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "repository") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><a class="bg" href="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/view_repository" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /></portlet:renderURL>"><%= repository.getName() %></a></font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileNameException.class.getName()) %>">
		<tr>
			<td colspan="3">

				<%
				String[] fileExtensions = PropsUtil.getArray(PropsUtil.DL_FILE_EXTENSIONS);
				%>

				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "document-names-must-end-with-one-of-the-following-extensions") %> <%= StringUtil.merge(fileExtensions, ", ") %>.</span></font>
			</td>
		</tr>
	</c:if>

	<c:if test="<%= SessionErrors.contains(renderRequest, DuplicateFileException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "please-enter-a-unique-document-name") %></span></font>
			</td>
		</tr>
	</c:if>

	<%--<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "document-name") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<input class="form-text" name="<portlet:namespace />file_name" type="text" value="<%= name %>">
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>--%>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileSizeException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "please-enter-a-file-with-a-valid-file-size") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td colspan="2"></td>
		<td>

			<%
			String fileMaxSize = Integer.toString(GetterUtil.getInteger(PropsUtil.get(PropsUtil.DL_FILE_MAX_SIZE)) / 1024);
			%>

			<font class="bg" size="2">
			<%= LanguageUtil.format(pageContext, "upload-documents-no-larger-than-x-k", fileMaxSize, false) %>
			</font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "file-location") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
                        <%--RMS-I
			<input class="form-text" name="<portlet:namespace />file_location" size="50" type="file">
                        --%>
                        <input name="<portlet:namespace />file_name" type="hidden" value="">
                        <input class="form-text" name="<portlet:namespace />file_location" size="50" type="file" onchange="document.getElementById('<portlet:namespace />file_name').value=this.value">
                        <%--RMS-F--%>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileProfileReadRolesException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "documents-require-at-least-one-read-role") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td colspan="3">
			<table border="0" cellpadding="0" cellspacing="2" width="100%">
			<tr>
				<td>
					<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "read-roles") %></b></font>
				</td>
			</tr>
			<tr>
				<td>

					<%
					List leftKVPs = new ArrayList();
					for (int i = 0; i < readRoles.length; i++) {
						leftKVPs.add(new KeyValuePair(readRoles[i].getName(), readRoles[i].getName()));
					}

					request.setAttribute(WebKeys.MOVE_BOXES_LEFT_LIST, leftKVPs);

					List rightKVPs = new ArrayList();
					for (int i = 0; i < roles.length; i++) {
						if (!readRolesSet.contains(roles[i])) {
							rightKVPs.add(new KeyValuePair(roles[i].getName(), roles[i].getName()));
						}
					}

					request.setAttribute(WebKeys.MOVE_BOXES_RIGHT_LIST, rightKVPs);
					%>

					<liferay:include page="/html/common/move_boxes.jsp" flush="true">
						<liferay:param name="form_name" value="<%= renderResponse.getNamespace() + \"fm\" %>" />
						<liferay:param name="left_title" value="<%= LanguageUtil.get(pageContext, \"current\") %>" />
						<liferay:param name="right_title" value="<%= LanguageUtil.get(pageContext, \"available\") %>" />
						<liferay:param name="left_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_rr2\" %>" />
						<liferay:param name="right_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_rr\" %>" />
					</liferay:include>
				</td>
			</tr>
			</table>

			<br>
		</td>
	</tr>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileProfileWriteRolesException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "documents-require-at-least-one-write-role") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td colspan="3">
			<table border="0" cellpadding="0" cellspacing="2" width="100%">
			<tr>
				<td>
					<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "write-roles") %></b></font>
				</td>
			</tr>
			<tr>
				<td>

					<%
					leftKVPs = new ArrayList();
					for (int i = 0; i < writeRoles.length; i++) {
						leftKVPs.add(new KeyValuePair(writeRoles[i].getName(), writeRoles[i].getName()));
					}

					request.setAttribute(WebKeys.MOVE_BOXES_LEFT_LIST, leftKVPs);

					rightKVPs = new ArrayList();
					for (int i = 0; i < roles.length; i++) {
						if (!writeRolesSet.contains(roles[i])) {
							rightKVPs.add(new KeyValuePair(roles[i].getName(), roles[i].getName()));
						}
					}

					request.setAttribute(WebKeys.MOVE_BOXES_RIGHT_LIST, rightKVPs);
					%>

					<liferay:include page="/html/common/move_boxes.jsp" flush="true">
						<liferay:param name="form_name" value="<%= renderResponse.getNamespace() + \"fm\" %>" />
						<liferay:param name="left_title" value="<%= LanguageUtil.get(pageContext, \"current\") %>" />
						<liferay:param name="right_title" value="<%= LanguageUtil.get(pageContext, \"available\") %>" />
						<liferay:param name="left_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_wr2\" %>" />
						<liferay:param name="right_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_wr\" %>" />
					</liferay:include>
				</td>
			</tr>
			</table>

			<br>
		</td>
	</tr>
	</table>

	<table border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td>
			<input type="submit" value="<%= LanguageUtil.get(pageContext, "add-document") %>">
		</td>
	</tr>
	</table>
</liferay:box>

</form>

<script language="JavaScript">
	document.<portlet:namespace />fm.<portlet:namespace />file_location.focus();
</script>