<%
/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/document_library/init.jsp" %>
<%@ page import="com.liferay.util.RMSCoder" %>
<%
DLRepository repository = (DLRepository)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_REPOSITORY);
DLFileProfile fileProfile = (DLFileProfile)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_FILE_PROFILE);

//RMS-I
//String path = fileProfile.getPath();
//String name = fileProfile.getShortFileName();
String path = RMSCoder.RMSEncode(fileProfile.getPath());
String name = RMSCoder.RMSEncode(fileProfile.getShortFileName());
//RMS-F

// All roles

Role[] roles = (Role[])CompanyLocalManagerUtil.getRoles(company.getCompanyId()).toArray(new Role[0]);

// Read roles

String[] readRoleNames = StringUtil.split(ParamUtil.getString(request, "file_rr"));
String readRoleNamesParam = request.getParameter("file_rr");
if (readRoleNamesParam == null) {
	if (fileProfile != null) {
		readRoleNames = StringUtil.split(fileProfile.getReadRoles());
	}
	else {
		readRoleNames = new String[] {Role.USER};
	}
}
List readRolesList = new ArrayList();
Set readRolesSet = new HashSet();
for (int i = 0; i < readRoleNames.length; i++) {
	try {
		Role readRole = RoleLocalManagerUtil.getRoleByName(company.getCompanyId(), readRoleNames[i]);

		readRolesList.add(readRole);
		readRolesSet.add(readRole);
	}
	catch (Exception e) {
	}
}
Role[] readRoles = (Role[])readRolesList.toArray(new Role[0]);

// Write roles

String[] writeRoleNames = StringUtil.split(ParamUtil.getString(request, "file_wr"));
String writeRoleNamesParam = request.getParameter("file_wr");
if (writeRoleNamesParam == null) {
	if (fileProfile != null) {
		writeRoleNames = StringUtil.split(fileProfile.getWriteRoles());
	}
	else {
		writeRoleNames = new String[] {Role.USER};
	}
}
List writeRolesList = new ArrayList();
Set writeRolesSet = new HashSet();
for (int i = 0; i < writeRoleNames.length; i++) {
	try {
		Role writeRole = RoleLocalManagerUtil.getRoleByName(company.getCompanyId(), writeRoleNames[i]);

		writeRolesList.add(writeRole);
		writeRolesSet.add(writeRole);
	}
	catch (Exception e) {
	}
}
Role[] writeRoles = (Role[])writeRolesList.toArray(new Role[0]);

DateFormat longDF = DateFormat.getDateInstance(DateFormat.LONG, locale);
%>

<form action="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/update_file_profile" /></portlet:actionURL>" method="post" name="<portlet:namespace />fm" onSubmit="document.<portlet:namespace />fm.<portlet:namespace />file_rr.value = listSelect(document.<portlet:namespace />fm.<portlet:namespace />file_sel_rr2); document.<portlet:namespace />fm.<portlet:namespace />file_wr.value = listSelect(document.<portlet:namespace />fm.<portlet:namespace />file_sel_wr2); submitForm(this); return false;">
<input name="<portlet:namespace /><%= Constants.CMD %>" type="hidden" value="<%= Constants.UPDATE %>">
<input name="<portlet:namespace />redirect" type="hidden" value="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/get_file_profile" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:renderURL>">
<input name="<portlet:namespace />repository_id" type="hidden" value="<%= repository.getRepositoryId() %>">
<input name="<portlet:namespace />file_path" type="hidden" value="<%= path %>">
<input name="<portlet:namespace />file_name" type="hidden" value="<%= name %>">
<input name="<portlet:namespace />file_rr" type="hidden" value="">
<input name="<portlet:namespace />file_wr" type="hidden" value="">

<liferay:box top="/html/common/box_top.jsp" bottom="/html/common/box_bottom.jsp">
	<liferay:param name="box_title" value="<%= LanguageUtil.get(pageContext, \"document-profile\") %>" />

	<table border="0" cellpadding="0" cellspacing="2">

	<c:if test="<%= !SessionErrors.isEmpty(renderRequest) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "you-have-entered-invalid-data") %></span></font>
			</td>
		</tr>
		<tr>
			<td colspan="3">
				<br>
			</td>
		</tr>
	</c:if>

	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "file-name") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><a class="bg" href="<%= CTX_PATH %>/document_library/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= path %>&file_name=<%= name %>"><%= fileProfile.getShortFileName() %></a></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "folder") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= path %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "repository") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><a class="bg" href="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/view_repository" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /></portlet:renderURL>"><%= repository.getName() %></a></font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "description") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td valign="top">
			<textarea class="form-text" cols="50" name="<portlet:namespace />file_desc" rows="5" wrap="virtual"><%= GetterUtil.get(fileProfile.getDescription(), StringPool.BLANK) %></textarea>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "version") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td valign="top">
			<font class="bg" size="2"><%= fileProfile.getVersion() %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "create-date") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= longDF.format(fileProfile.getCreateDate()) %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "size") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= TextFormatter.formatKB(fileProfile.getSize(), locale) %>k</font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="1">
			<br>
			</font>

			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "download-link") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="1">
			<%= LanguageUtil.get(pageContext, "cut-and-paste-the-full-url-to-use-as-a-hyperlink") %><br>
			</font>

			<input size="50" type="text" value="http://<%= company.getPortalURL() %><%= CTX_PATH %>/document_library/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= path %>&file_name=<%= name %>">
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileProfileReadRolesException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "documents-require-at-least-one-read-role") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td colspan="3">
			<table border="0" cellpadding="0" cellspacing="2" width="100%">
			<tr>
				<td>
					<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "read-roles") %></b></font>
				</td>
			</tr>
			<tr>
				<td>

					<%
					List leftKVPs = new ArrayList();
					for (int i = 0; i < readRoles.length; i++) {
						leftKVPs.add(new KeyValuePair(readRoles[i].getName(), readRoles[i].getName()));
					}

					request.setAttribute(WebKeys.MOVE_BOXES_LEFT_LIST, leftKVPs);

					List rightKVPs = new ArrayList();
					for (int i = 0; i < roles.length; i++) {
						if (!readRolesSet.contains(roles[i])) {
							rightKVPs.add(new KeyValuePair(roles[i].getName(), roles[i].getName()));
						}
					}

					request.setAttribute(WebKeys.MOVE_BOXES_RIGHT_LIST, rightKVPs);
					%>

					<liferay:include page="/html/common/move_boxes.jsp" flush="true">
						<liferay:param name="form_name" value="<%= renderResponse.getNamespace() + \"fm\" %>" />
						<liferay:param name="left_title" value="<%= LanguageUtil.get(pageContext, \"current\") %>" />
						<liferay:param name="right_title" value="<%= LanguageUtil.get(pageContext, \"available\") %>" />
						<liferay:param name="left_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_rr2\" %>" />
						<liferay:param name="right_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_rr\" %>" />
					</liferay:include>
				</td>
			</tr>
			</table>

			<br>
		</td>
	</tr>

	<c:if test="<%= SessionErrors.contains(renderRequest, FileProfileWriteRolesException.class.getName()) %>">
		<tr>
			<td colspan="3">
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "documents-require-at-least-one-write-role") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td colspan="3">
			<table border="0" cellpadding="0" cellspacing="2" width="100%">
			<tr>
				<td>
					<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "write-roles") %></b></font>
				</td>
			</tr>
			<tr>
				<td>

					<%
					leftKVPs = new ArrayList();
					for (int i = 0; i < writeRoles.length; i++) {
						leftKVPs.add(new KeyValuePair(writeRoles[i].getName(), writeRoles[i].getName()));
					}

					request.setAttribute(WebKeys.MOVE_BOXES_LEFT_LIST, leftKVPs);

					rightKVPs = new ArrayList();
					for (int i = 0; i < roles.length; i++) {
						if (!writeRolesSet.contains(roles[i])) {
							rightKVPs.add(new KeyValuePair(roles[i].getName(), roles[i].getName()));
						}
					}

					request.setAttribute(WebKeys.MOVE_BOXES_RIGHT_LIST, rightKVPs);
					%>

					<liferay:include page="/html/common/move_boxes.jsp" flush="true">
						<liferay:param name="form_name" value="<%= renderResponse.getNamespace() + \"fm\" %>" />
						<liferay:param name="left_title" value="<%= LanguageUtil.get(pageContext, \"current\") %>" />
						<liferay:param name="right_title" value="<%= LanguageUtil.get(pageContext, \"available\") %>" />
						<liferay:param name="left_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_wr2\" %>" />
						<liferay:param name="right_box_name" value="<%= renderResponse.getNamespace() + \"file_sel_wr\" %>" />
					</liferay:include>
				</td>
			</tr>
			</table>

			<br>
		</td>
	</tr>
	</table>

	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td align="center">
			<input type="submit" value="<%= LanguageUtil.get(pageContext, "update") %>">

			<input type="button" value="<%= LanguageUtil.get(pageContext, "cancel") %>" onClick="self.location = '<portlet:renderURL><portlet:param name="struts_action" value="/document_library/get_file_profile" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:renderURL>';">
		</td>
	</tr>
	</table>
</liferay:box>

</form>

<script language="JavaScript">
	document.<portlet:namespace />fm.<portlet:namespace />file_desc.focus();
</script>