<%
/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/document_library/init.jsp" %>

<%@ page import="com.liferay.util.RMSCoder" %>

<%
DLRepository repository = (DLRepository)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_REPOSITORY);
DLFileProfile fileProfile = (DLFileProfile)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_FILE_PROFILE);
List fileVersions = (List)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_FILE_VERSIONS);

//RMS-I
//String path = fileProfile.getPath();
//String name = fileProfile.getShortFileName();
String path = RMSCoder.RMSEncode(fileProfile.getPath());
String name = RMSCoder.RMSEncode(fileProfile.getShortFileName());
//RMS-F

DateFormat longDF = DateFormat.getDateInstance(DateFormat.LONG, locale);
DateFormat shortDF = DateFormat.getDateInstance(DateFormat.SHORT, locale);
%>

<form action="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/update_file" /></portlet:actionURL>" enctype="multipart/form-data" method="post" name="<portlet:namespace />fm"
	onSubmit="
		alert('<%= UnicodeLanguageUtil.get(pageContext, "please-be-patient-while-uploading-your-file") %>');
		<liferay:upload-progress />
		submitForm(this);
		return false;"
>
<input name="<portlet:namespace />redirect" type="hidden" value="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/get_file_profile" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:renderURL>">
<input name="<portlet:namespace />repository_id" type="hidden" value="<%= repository.getRepositoryId() %>">
<input name="<portlet:namespace />file_path" type="hidden" value="<%= path %>">
<input name="<portlet:namespace />file_name" type="hidden" value="<%= name %>">

<%
boolean hasLock = LockManagerUtil.hasLock(DLFileProfile.class.getName(), fileProfile.getPrimaryKey(), user.getUserId());
%>

<c:if test="<%= hasLock %>">

	<%
	String lockExpirationTime = LanguageUtil.getTimeDescription(pageContext, DLFileProfile.LOCK_EXPIRATION_TIME).toLowerCase();
	%>

	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><%= LanguageUtil.format(pageContext, "you-now-have-a-lock-on-this-document", lockExpirationTime, false) %></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<c:if test="<%= SessionMessages.contains(renderRequest, DeleteFileVersionAction.class.getName()) %>">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><span class="bg-pos-alert"><%= LanguageUtil.get(pageContext, "you-have-successfully-deleted-a-version-of-this-document") %></span></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<c:if test="<%= SessionMessages.contains(renderRequest, UpdateFileAction.class.getName()) %>">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><span class="bg-pos-alert"><%= LanguageUtil.get(pageContext, "you-have-successfully-uploaded-a-new-version-of-this-document") %></span></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<c:if test="<%= SessionMessages.contains(renderRequest, UpdateFileProfileAction.class.getName()) %>">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><span class="bg-pos-alert"><%= LanguageUtil.get(pageContext, "you-have-successfully-updated-the-document-profile") %></span></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<c:if test="<%= !SessionErrors.isEmpty(renderRequest) %>">
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "you-have-entered-invalid-data") %></span></font>
		</td>
	</tr>
	</table>

	<br>
</c:if>

<liferay:box top="/html/common/box_top.jsp" bottom="/html/common/box_bottom.jsp">
	<liferay:param name="box_title" value="<%= LanguageUtil.get(pageContext, \"document-profile\") %>" />

	<table border="0" cellpadding="0" cellspacing="2">
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "file-name") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><a class="bg" href="<%= CTX_PATH %>/document_library/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= Http.encodeURL(path) %>&file_name=<%= Http.encodeURL(name) %>"><%= fileProfile.getShortFileName() %></a></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "folder") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= path %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "repository") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><a class="bg" href="<portlet:renderURL><portlet:param name="struts_action" value="/document_library/view_repository" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /></portlet:renderURL>"><%= repository.getName() %></a></font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "description") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td valign="top">
			<font class="bg" size="2"><%= fileProfile.getDescription() %></font>
		</td>
	</tr>
	<tr>
		<td valign="top">
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "version") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td valign="top">
			<font class="bg" size="2"><%= fileProfile.getVersion() %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "create-date") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= longDF.format(fileProfile.getCreateDate()) %></font>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "size") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="2"><%= TextFormatter.formatKB(fileProfile.getSize(), locale) %>k</font>
		</td>
	</tr>
	<tr>
		<td colspan="3">
			<br>
		</td>
	</tr>
	<tr>
		<td>
			<font class="bg" size="1">
			<br>
			</font>

			<font class="bg" size="2"><b><%= LanguageUtil.get(pageContext, "download-link") %></b></font>
		</td>
		<td width="10">
			&nbsp;
		</td>
		<td>
			<font class="bg" size="1">
			<%= LanguageUtil.get(pageContext, "cut-and-paste-the-full-url-to-use-as-a-hyperlink") %><br>
			</font>
			<input size="50" type="text" value="http://<%= company.getPortalURL() %><%= CTX_PATH %>/document_library/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= Http.encodeURL(path) %>&file_name=<%= Http.encodeURL(name) %>">
		</td>
	</tr>
	</table>

	<br>

	<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr>
		<td align="center">

			<%
			PortletURL getFileProfileURL = renderResponse.createRenderURL();

			getFileProfileURL.setParameter("struts_action", "/document_library/get_file_profile");
			getFileProfileURL.setParameter("repository_id", repository.getRepositoryId());
			getFileProfileURL.setParameter("file_path", path);
			getFileProfileURL.setParameter("file_name", name);

			PortletURL viewRepositoryURL = renderResponse.createRenderURL();

			viewRepositoryURL.setParameter("struts_action", "/document_library/view_repository");
			viewRepositoryURL.setParameter("repository_id", repository.getRepositoryId());
			%>

			<table border="0" cellpadding="0" cellspacing="0">
			<tr>
				<td>
					<input type="button" value="<%= LanguageUtil.get(pageContext, "edit-profile") %>" onClick="self.location = '<portlet:renderURL><portlet:param name="struts_action" value="/document_library/edit_file_profile" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:renderURL>';">

					<c:if test="<%= !hasLock %>">
						<input type="button" value="<%= LanguageUtil.get(pageContext, "lock") %>" onClick="self.location = '<portlet:actionURL><portlet:param name="struts_action" value="/document_library/lock_file" /><portlet:param name="redirect" value="<%= getFileProfileURL.toString() %>" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>';">
					</c:if>

					<c:if test="<%= hasLock %>">
						<input type="button" value="<%= LanguageUtil.get(pageContext, "unlock") %>" onClick="self.location = '<portlet:actionURL><portlet:param name="struts_action" value="/document_library/unlock_file" /><portlet:param name="redirect" value="<%= getFileProfileURL.toString() %>" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>';">
					</c:if>

					<input type="button" value="<%= LanguageUtil.get(pageContext, "delete") %>" onClick="if (confirm('<%= UnicodeLanguageUtil.get(pageContext, "are-you-sure-you-want-to-delete-the-selected-document-and-all-its-versions") %>')) { self.location = '<portlet:actionURL><portlet:param name="struts_action" value="/document_library/delete_file" /><portlet:param name="redirect" value="<%= viewRepositoryURL.toString() %>" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>'; }">
				</td>
				<td width="30">
					&nbsp;
				</td>
				<td>
					<input type="button" value="<%= LanguageUtil.get(pageContext, "download") %>" onClick="self.location = '<%= CTX_PATH %>/document_library/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= Http.encodeURL(path) %>&file_name=<%= Http.encodeURL(name) %>';">
        			</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
</liferay:box>

<br>

<liferay:box top="/html/common/box_top.jsp" bottom="/html/common/box_bottom.jsp">
	<liferay:param name="box_title" value="<%= LanguageUtil.get(pageContext, \"upload-new-version\") %>" />

	<table border="0" cellpadding="0" cellspacing="2">

	<c:if test="<%= SessionErrors.contains(renderRequest, FileSizeException.class.getName()) %>">
		<tr>
			<td>
				<font class="bg" size="1"><span class="bg-neg-alert"><%= LanguageUtil.get(pageContext, "please-enter-a-file-with-a-valid-file-size") %></span></font>
			</td>
		</tr>
	</c:if>

	<tr>
		<td align="center">
			<table border="0" cellpadding="0" cellspacing="0">
			<tr>
				<td>

					<%
					String fileMaxSize = Integer.toString(GetterUtil.getInteger(PropsUtil.get(PropsUtil.DL_FILE_MAX_SIZE)) / 1024);
					%>

					<font class="bg" size="2">
					<%= LanguageUtil.format(pageContext, "upload-documents-no-larger-than-x-k", fileMaxSize, false) %>
					</font>
				</td>
			</tr>
			<tr>
				<td>
                                        <input class="form-text" name="<portlet:namespace />file_location" size="30" type="file">
				</td>
			</tr>
			</table>

			<br>

			<input type="submit" value="<%= LanguageUtil.get(pageContext, "upload-new-version") %>">
		</td>
	</tr>
	</table>
</liferay:box>

<br>

<%@ include file="/html/portlet/document_library/version_history.jsp" %>

</form>

<script language="JavaScript">
	document.<portlet:namespace />fm.<portlet:namespace />file_location.focus();
</script>