<%
/**
 * Copyright (c) 2000-2005 Liferay, LLC. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%>

<%@ include file="/html/portlet/document_library/init.jsp" %>
<%@ page import="com.liferay.util.RMSCoder" %>

<%
DLRepository repository = (DLRepository)request.getAttribute(WebKeys.DOCUMENT_LIBRARY_REPOSITORY);

List fileList = DLFileProfileManagerUtil.getDirectoryView(repository.getRepositoryId()).getFileList();
%>

<script language="JavaScript" src="<%= contextPath %>/html/js/tree.js"></script>
<script language="JavaScript">
	var dlIcons	= new Array();

	// Basic icons

	dlIcons[0] = "<%= COMMON_IMG %>/trees/root.gif";
	dlIcons[1] = "<%= COMMON_IMG %>/trees/spacer.gif";
	dlIcons[2] = "<%= COMMON_IMG %>/trees/line.gif";
	dlIcons[3] = "<%= COMMON_IMG %>/trees/join.gif";
	dlIcons[4] = "<%= COMMON_IMG %>/trees/join_bottom.gif";
	dlIcons[5] = "<%= COMMON_IMG %>/trees/minus.gif";
	dlIcons[6] = "<%= COMMON_IMG %>/trees/minus_bottom.gif";
	dlIcons[7] = "<%= COMMON_IMG %>/trees/plus.gif";
	dlIcons[8] = "<%= COMMON_IMG %>/trees/plus_bottom.gif";
	dlIcons[9] = "<%= COMMON_IMG %>/trees/folder.gif";
	dlIcons[10] = "<%= COMMON_IMG %>/trees/folder_open.gif";
	dlIcons[11] = "<%= COMMON_IMG %>/trees/page.gif";

	// More icons

	dlIcons[12] = "<%= COMMON_IMG %>/document_library/doc.gif";
	dlIcons[13] = "<%= COMMON_IMG %>/document_library/pdf.gif";
	dlIcons[14] = "<%= COMMON_IMG %>/document_library/ppt.gif";
	dlIcons[15] = "<%= COMMON_IMG %>/document_library/rtf.gif";
	dlIcons[16] = "<%= COMMON_IMG %>/document_library/sxc.gif";
	dlIcons[17] = "<%= COMMON_IMG %>/document_library/sxi.gif";
	dlIcons[18] = "<%= COMMON_IMG %>/document_library/sxw.gif";
	dlIcons[19] = "<%= COMMON_IMG %>/document_library/txt.gif";
	dlIcons[20] = "<%= COMMON_IMG %>/document_library/xls.gif";

	// id | parentId | ls | path | name | img | href

	var dlArray = new Array();

	dlArray[0] = "<%= UnicodeFormatter.toString(StringUtil.replace((String)fileList.get(0), "Root", repository.getName())) %>|javascript: <portlet:namespace />showPopUp('dlTree_pop_up_0');";

	<%
	for (int i = 1; i < fileList.size(); i++) {
		String fileDesc = (String)fileList.get(i);
	%>

		dlArray[<%= i %>] = "<%= UnicodeFormatter.toString(fileDesc) %>|javascript: <portlet:namespace />showPopUp('dlTree_pop_up_<%= i %>');";

	<%
	}
	%>

	function <portlet:namespace />showPopUp(popUpId) {

		<%
		for (int i = 0; i < fileList.size(); i++) {
			String fileDesc = (String)fileList.get(i);

			String[] nodeValues = StringUtil.split(fileDesc, "|");

			String path = Http.encodeURL(nodeValues[3]);
			String name = Http.encodeURL(nodeValues[4]);
		%>

			<c:if test="<%= portletConfig.getPortletName().equals(PortletKeys.DOCUMENT_LIBRARY) %>">
				if (popUpId == "dlTree_pop_up_<%= i %>") {
					showPopUp(popUpId);
				}
			</c:if>

			<c:if test="<%= !portletConfig.getPortletName().equals(PortletKeys.DOCUMENT_LIBRARY) && GetterUtil.getInteger(nodeValues[5]) >= 11 %>">
				if (popUpId == "dlTree_pop_up_<%= i %>") {
					self.location = "<%= CTX_PATH %>/<%= portlet.getStrutsPath() %>/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= path %>&file_name=<%= name %>";
				}
			</c:if>

		<%
		}
		%>

	}
</script>

<c:if test="<%= portletConfig.getPortletName().equals(PortletKeys.DOCUMENT_LIBRARY) %>">

	<%
	PortletURL portletURL = renderResponse.createRenderURL();

	portletURL.setParameter("struts_action", "/document_library/view_repository");
	portletURL.setParameter("repository_id", repository.getRepositoryId());

	String portletURLToString = portletURL.toString();
	%>

	<table border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td nowrap>

			<%
			for (int i = 0; i < fileList.size(); i++) {
				String fileDesc = (String)fileList.get(i);

				String[] nodeValues = StringUtil.split(fileDesc, "|");
                                //RMS-I
				//String path = nodeValues[3];
				//String name = nodeValues[4];
				String path = RMSCoder.RMSEncode(nodeValues[3]);
				String name = RMSCoder.RMSEncode(nodeValues[4]);
                                //RMS-F
			%>

				<c:if test="<%= nodeValues[5].equals(\"0\") %>">
					<div id="dlTree_pop_up_<%= i %>" style="background-color: LightGrey; border: 2px Outset White; layer-background-color: LightGrey; padding: 4; position: absolute; visibility: hidden;" onMouseOver="menuOnMouseOver('dlTree_pop_up_<%= i %>');" onMouseOut="menuOnMouseOut('dlTree_pop_up_<%= i %>');">
						<font class="gamma" size="1">
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/add_directory" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="/" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "add-folder") %></a><br>
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/add_file" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="/" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "add-document") %></a><br>
						<a class="gamma" href="javascript: hidePopUp('dlTree_pop_up_<%= i %>');" style="text-decoration: none;"><b>X</b></a><br>
						</font>
					</div>
				</c:if>
				<c:if test="<%= nodeValues[5].equals(\"9\") %>">
					<div id="dlTree_pop_up_<%= i %>" style="background-color: LightGrey; border: 2px Outset White; layer-background-color: LightGrey; padding: 4; position: absolute; visibility: hidden;" onMouseOver="menuOnMouseOver('dlTree_pop_up_<%= i %>');" onMouseOut="menuOnMouseOut('dlTree_pop_up_<%= i %>');">
						<font class="gamma" size="1">
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/add_directory" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path + \"/\" + name %>" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "add-folder") %></a><br>
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/add_file" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path + \"/\" + name %>" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "add-document") %></a><br>
						<a class="gamma" href="javascript: if (confirm('<%= UnicodeLanguageUtil.get(pageContext, "are-you-sure-you-want-to-delete-the-selected-folder-and-all-its-contents") %>')) { self.location = '<portlet:actionURL><portlet:param name="struts_action" value="/document_library/delete_directory" /><portlet:param name="redirect" value="<%= Http.encodeURL(portletURLToString) %>" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>'; }" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "delete-folder") %></a><br>
						<a class="gamma" href="javascript: hidePopUp('dlTree_pop_up_<%= i %>');" style="text-decoration: none;"><b>X</b></a><br>
						</font>
					</div>
				</c:if>
				<c:if test="<%= GetterUtil.getInteger(nodeValues[5]) >= 11 %>">
					<div id="dlTree_pop_up_<%= i %>" style="background-color: LightGrey; border: 2px Outset White; layer-background-color: LightGrey; padding: 4; position: absolute; visibility: hidden;" onMouseOver="menuOnMouseOver('dlTree_pop_up_<%= i %>');" onMouseOut="menuOnMouseOut('dlTree_pop_up_<%= i %>');">
						<font class="gamma" size="1">
						<a class="gamma" href="<%= CTX_PATH %>/<%= portlet.getStrutsPath() %>/get_file?repository_id=<%= repository.getRepositoryId() %>&file_path=<%= path %>&file_name=<%= name %>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "open-document") %></a><br>
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/get_file_profile" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "edit-document") %></a><br>
						<a class="gamma" href="javascript: if (confirm('<%= UnicodeLanguageUtil.get(pageContext, "are-you-sure-you-want-to-delete-the-selected-document-and-all-its-versions") %>')) { self.location = '<portlet:actionURL><portlet:param name="struts_action" value="/document_library/delete_file" /><portlet:param name="redirect" value="<%= Http.encodeURL(portletURLToString) %>" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>'; }" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "delete-document") %></a><br>
						<a class="gamma" href="<portlet:actionURL><portlet:param name="struts_action" value="/document_library/get_file_versions" /><portlet:param name="repository_id" value="<%= repository.getRepositoryId() %>" /><portlet:param name="file_path" value="<%= path %>" /><portlet:param name="file_name" value="<%= name %>" /></portlet:actionURL>" style="text-decoration: none;"><%= LanguageUtil.get(pageContext, "view-history") %></a><br>
						<a class="gamma" href="javascript: hidePopUp('dlTree_pop_up_<%= i %>');" style="text-decoration: none;"><b>X</b></a><br>
						</font>
					</div>
				</c:if>
			<%
			}
			%>

		</td>
	</tr>
	</table>
</c:if>